;-----------------------------------------------------------------------
;compiler settings
;-----------------------------------------------------------------------

header
hirom

;-----------------------------------------------------------------------
;reel sequence
;-----------------------------------------------------------------------
org $c2a800

    ;first slot
    db $00, $00         ;7
    db $01, $00         ;dragon
    db $04, $00         ;chocobo
    db $03, $00         ;ship
    db $02, $00         ;BAR
    db $05, $00         ;diamond
    db $01, $00         ;dragon
    db $04, $00         ;chocobo
    db $00, $00         ;7
    db $03, $00         ;ship
    db $05, $00         ;diamond
    db $01, $00         ;dragon
    db $02, $00         ;BAR
    db $04, $00         ;chocobo
    db $03, $00         ;ship
    db $05, $00         ;diamond

    ;second slot
    db $00, $00         ;7
    db $01, $00         ;dragon
    db $04, $00         ;chocobo
    db $03, $00         ;ship
    db $02, $00         ;BAR
    db $05, $00         ;diamond
    db $01, $00         ;dragon
    db $04, $00         ;chocobo
    db $00, $00         ;7
    db $03, $00         ;ship
    db $05, $00         ;diamond
    db $01, $00         ;dragon
    db $02, $00         ;BAR
    db $04, $00         ;chocobo
    db $03, $00         ;ship
    db $05, $00         ;diamond

    ;third slot
    db $00, $00         ;7
    db $01, $00         ;dragon
    db $04, $00         ;chocobo
    db $03, $00         ;ship
    db $02, $00         ;BAR
    db $05, $00         ;diamond
    db $01, $00         ;dragon
    db $04, $00         ;chocobo
    db $00, $00         ;7
    db $03, $00         ;ship
    db $05, $00         ;diamond
    db $01, $00         ;dragon
    db $02, $00         ;BAR
    db $04, $00         ;chocobo
    db $03, $00         ;ship
    db $05, $00         ;diamond

warnpc $c2a860

;-----------------------------------------------------------------------
;unrig reel
;-----------------------------------------------------------------------

org $c17f32
     stz $6179          ;rigging flags
warnpc $c17f35

org $c17f5e
     lda #$00           ;nulls rigging
warnpc $c17f60

org $c17f9d
     lda #$00           ;nulls rigging
warnpc $c17f9f

;-----------------------------------------------------------------------
;spell table and auxiliary functions
;-----------------------------------------------------------------------
org $c2a7ca

table_spell:

    db 255, 255, 255        ;7:         esper, esper, esper
    db   2,   7,  11        ;bird:      bolt 1, bolt 2, bolt 3
    db 254, 254, 254        ;BAR:       lagomorph, lagomorph, lagomorph
    db   0,   5,   9        ;ship:      fire 1, fire 2, fire 3
    db  45,  46,  47        ;chocobo:   cure 1, cure 2, cure 3
    db   1,   6,  10        ;diamond:   ice 1, ice 2, ice 3  

symbol_random:
;get symbol from random slot
;A out = random symbol

	php : sep #$30              ;mode 1AX
    lda #$03 : jsr $4b65        ;get random number [0, 2]
	tax : lda $36,x			    ;get random reel symbol
	plp : rts				    ;exit

symbol_counter:
;get quantity of input symbol
;A in = symbol to check
;A out = quantity

    php : sep #$30              ;mode 1AX
	ldx #$00			        ;null X
	cmp $36 : bne +			    ;compare first reel
	inx
+	cmp $37 : bne +			    ;compare first reel
	inx
+	cmp $38 : bne +			    ;compare first reel
	inx
+	txa : plp : rts			    ;get result

warnpc $c2a800

;-----------------------------------------------------------------------
symbol_selector:
;choose symbol from reels
;-----------------------------------------------------------------------
org $c2b4a3

	;get random symbol
    jsr symbol_random		    ;get random symbol
	pha : pha                   ;save it in buffer/stack twice
    asl : clc : adc $02,s       ;A = A*3
    sta $02,s                   ;save A*3 in buffer
	
    ;get symbol power
    pla : jsr symbol_counter    ;get symbol quantity
	dec                         ;adjust to table
    clc : adc $01,s             ;add symbol table offset
    sta $01,s                   ;update it

    ;exit
    pla : rtl                   ;exit

warnpc $c2b4be

;-----------------------------------------------------------------------
symbol_spells:
;setup spells from choosen symbol
;-----------------------------------------------------------------------
org $c24db8

	xba : tax                   ;get index (symbol id*3 + symbol quantity)
    lda.l table_spell,x	        ;get spell
    cmp #$ff : bne +            ;skip if not random esper
    jsr $37dc                   ;pick random esper 
+	xba : jmp $4ddb             ;exit

warnpc $c24ddb

;-----------------------------------------------------------------------
name_fix:
;fix display of spell names
;-----------------------------------------------------------------------
org $c21726

    ;original setting
    lda #$10 : trb $b0              ;?flags
    
    ;check names
    jmp $175f                       ;setup default names
    
warnpc $c21741
